<?php
##### rradminbranches_lib.php, created by ###Admin Branches, by Robin Richmond
# PHP library file created by the Admin Branches mod
# This library is used by admin_branches.php and admin_editbranch.php (in both cases,
# as a result of modifications made by the Admin Branches mod) and by the new program
# rradminbranches_ajx.php (which is also created by the Admin Branches mod).
#
# Contains:
# function getBranchRecordCount, which was originally getBranchCount in admin_branchs.php.
# function getBranchIndexCount, which counts records in the Branch Index.
# function getAllBranchCounts, which returns a two dimensional array indexed by
#         ["index"|"records"] and ["people"|"families"]
$tngModNames['Admin Branches']['rradminbranches_lib.php'] = '2a'; #Register this mod

##############################################
# Function to count Person or Family records in $branch; i.e. that have $branch in
# their branch field.
# $table is the People table name or the Families table name.
# If $countLabels is false, then just indicate with Y or N whether there are any labels.
function getBranchRecordCount($tree, $branch, $table, $countLabels=false) {
	global $admtext;

	if ($countLabels) { #Count them for real
		$query = "SELECT count(*) AS count FROM $table WHERE gedcom = '$tree' AND branch LIKE '%$branch%'";
		$result = tng_query($query);
		$row = tng_fetch_assoc($result);
		$count = $row['count'];
		if(!$count) $count = "0";
	} else { #Just see if there are any labels
		$query = "SELECT ID FROM $table
			WHERE gedcom = '$tree' AND branch LIKE '%$branch%'
			LIMIT 1";
		$result = tng_query($query);
		$count = (tng_num_rows($result) == 1) ? "Y" : "N";
	}
	tng_free_result($result);
	return $count;
} #end function getBranchRecordCount

#############################################################
# Count records in $branch in the Branch Index
# One call to this function gets the Person OR Family count.
# $recordtype is the Person or Family prefix - usually "I" or "F".
# If $countLabels is false, then just indicate with Y or N whether there are any labels.
function getBranchIndexCount($tree, $branch, $recordtype, $countLabels=false) {
	global $branchlinks_table;
	if ($countLabels) { #Count them for real
		$query = "SELECT count(ID) as count FROM $branchlinks_table
			WHERE gedcom = \"$tree\" and branch =\"$branch\" and persfamID LIKE '$recordtype%'";
		$result = tng_query($query);
		$row = tng_fetch_assoc($result);
		$count = $row['count'];
		if(!$count) $count = "0";
	} else { #Just see if there are any labels
		$query = "SELECT ID FROM $branchlinks_table
			WHERE gedcom='$tree' AND branch='$branch' AND left(persfamid,1)='$recordtype'
			LIMIT 1";
		$result = tng_query($query);
		$count = (tng_num_rows($result) == 1) ? "Y" : "N";
	}
 	tng_free_result($result);
	return $count;
} #end function getBranchIndexCount

#################################################
# Function to return the count of People and Families record with the branch, and
# the People and Families counts from the branch index.
# Return a two-dimensional array with 'records'/'index' as the first index and
#'people'/'families' as the second.
function getAllBranchCounts($tree, $branch, $countLabels=false) {
	global $tngconfig; #We need the person and family prefixes
	global $people_table, $families_table;

	$result = array();
	$result['records']['people'] = getBranchRecordCount($tree, $branch, $people_table, $countLabels);
	$result['records']['families'] = getBranchRecordCount($tree, $branch, $families_table, $countLabels);
	$result['index']['people'] = getBranchIndexCount($tree, $branch, $tngconfig['personprefix'], $countLabels);
	$result['index']['families'] = getBranchIndexCount($tree, $branch, $tngconfig['familyprefix'], $countLabels);
	if ($result['records']['people'] != $result['index']['people']) {
		$result['records']['people'] = "<span style='color:red;font-weight:strong;'>{$result['records']['people']}</span>";
		$result['index']['people'] = "<span style='color:red;font-weight:strong;'>{$result['index']['people']}</span>";
	}
	if ($result['records']['families'] != $result['index']['families']) {
		$result['records']['families'] = "<span style='color:red;font-weight:strong;'>{$result['records']['families']}</span>";
		$result['index']['families'] = "<span style='color:red;font-weight:strong;'>{$result['index']['families']}</span>";
	}
	return $result;
} #End function getAllBranchCounts
?>